<?php
/**
 * Slider Options
 *
 * @package Weddi_Pro
 */

class Weddi_Pro_Slider_Options {
	public function __construct() {
		// Register Slider Options.
		add_action( 'customize_register', array( $this, 'register_options' ), 98 );

		// Add default options.
		add_filter( 'weddi_pro_customizer_defaults', array( $this, 'add_defaults' ) );
	}

	/**
	 * Add options to defaults
	 */
	public function add_defaults( $default_options ) {
		$defaults = array(
			'weddi_pro_slider_visibility'     => 'disabled',
			'weddi_pro_slider_number'         => 2,
			'weddi_pro_slider_autoplay_delay' => 5000,
			'weddi_pro_slider_pause_on_hover' => 1,
			'weddi_pro_slider_navigation'     => 1,
			'weddi_pro_slider_pagination'     => 1,
		);

		$updated_defaults = wp_parse_args( $defaults, $default_options );

		return $updated_defaults;
	}

	/**
	 * Add slider section and its controls
	 */
	public function register_options( $wp_customize ) {
		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'settings'          => 'weddi_pro_slider_visibility',
				'type'              => 'select',
				'sanitize_callback' => 'weddi_pro_sanitize_select',
				'label'             => esc_html__( 'Visible On', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_slider',
				'choices'           => Weddi_Pro_Customizer_Utilities::section_visibility(),
			)
		);

		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'type'              => 'number',
				'settings'          => 'weddi_pro_slider_number',
				'label'             => esc_html__( 'Number', 'weddi-pro' ),
				'description'       => esc_html__( 'Please refresh the customizer page once the number is changed.', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_slider',
				'sanitize_callback' => 'absint',
				'input_attrs'       => array(
					'min'   => 1,
					'max'   => 80,
					'step'  => 1,
					'style' => 'width:100px;',
				),
				'active_callback'   => array( $this, 'is_slider_visible' ),
			)
		);

		$numbers = weddi_pro_gtm( 'weddi_pro_slider_number' );

		for( $i = 0, $j = 1; $i < $numbers; $i++, $j++ ) {
			Weddi_Pro_Customizer_Utilities::register_option(
				array(
					'custom_control'    => 'Weddi_Pro_Simple_Notice_Custom_Control',
					'sanitize_callback' => 'weddi_pro_text_sanitization',
					'settings'          => 'weddi_pro_slider_notice_' . $i,
					'label'             => esc_html__( 'Item #', 'weddi-pro' )  . $j,
					'section'           => 'weddi_pro_ss_slider',
					'active_callback'   => array( $this, 'is_slider_visible' ),
				)
			);

			Weddi_Pro_Customizer_Utilities::register_option(
				array(
					'custom_control'    => 'Weddi_Pro_Dropdown_Posts_Custom_Control',
					'sanitize_callback' => 'absint',
					'settings'          => 'weddi_pro_slider_page_' . $i,
					'label'             => esc_html__( 'Select Page', 'weddi-pro' ),
					'section'           => 'weddi_pro_ss_slider',
					'active_callback'   => array( $this, 'is_slider_visible' ),
					'input_attrs' => array(
						'post_type'      => 'page',
						'posts_per_page' => -1,
						'orderby'        => 'name',
						'order'          => 'ASC',
					),
				)
			);
		}

		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'custom_control'    => 'Weddi_Pro_Toggle_Switch_Custom_control',
				'settings'          => 'weddi_pro_slider_autoplay',
				'sanitize_callback' => 'weddi_pro_switch_sanitization',
				'label'             => esc_html__( 'Autoplay', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_slider',
				'active_callback'   => array( $this, 'is_slider_visible' ),
			)
		);

		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'settings'          => 'weddi_pro_slider_autoplay_delay',
				'type'              => 'number',
				'sanitize_callback' => 'absint',
				'label'             => esc_html__( 'Autoplay Delay', 'weddi-pro' ),
				'description'       => esc_html__( '(in ms)', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_slider',
				'input_attrs'           => array(
					'width' => '10px',
				),
				'active_callback'   => array( $this, 'is_slider_autoplay_on' ),
			)
		);

		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'custom_control'    => 'Weddi_Pro_Toggle_Switch_Custom_control',
				'settings'          => 'weddi_pro_slider_pause_on_hover',
				'sanitize_callback' => 'weddi_pro_switch_sanitization',
				'label'             => esc_html__( 'Pause On Hover', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_slider',
				'active_callback'   => array( $this, 'is_slider_autoplay_on' ),
			)
		);

		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'custom_control'    => 'Weddi_Pro_Toggle_Switch_Custom_control',
				'settings'          => 'weddi_pro_slider_navigation',
				'sanitize_callback' => 'weddi_pro_switch_sanitization',
				'label'             => esc_html__( 'Navigation', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_slider',
				'active_callback'   => array( $this, 'is_slider_visible' ),
			)
		);

		Weddi_Pro_Customizer_Utilities::register_option(
			array(
				'custom_control'    => 'Weddi_Pro_Toggle_Switch_Custom_control',
				'settings'          => 'weddi_pro_slider_pagination',
				'sanitize_callback' => 'weddi_pro_switch_sanitization',
				'label'             => esc_html__( 'Pagination', 'weddi-pro' ),
				'section'           => 'weddi_pro_ss_slider',
				'active_callback'   => array( $this, 'is_slider_visible' ),
			)
		);
	}

	/**
	 * Slider visibility active callback.
	 */
	public function is_slider_visible( $control ) {
		return ( weddi_pro_display_section( $control->manager->get_setting( 'weddi_pro_slider_visibility' )->value() ) );
	}

	/**
	 * Slider autoplay check.
	 */
	public function is_slider_autoplay_on( $control ) {
		return ( $this->is_slider_visible( $control ) && $control->manager->get_setting( 'weddi_pro_slider_autoplay' )->value() );
	}
}

/**
 * Initialize class
 */
$slider_ss_slider = new Weddi_Pro_Slider_Options();
